;********************************************************************
;*                    LCD 4000                                      *
;*     Zkusbni rutina spektrofotometru                              *
;*                  Stav ke dni 15.11.1992                          *
;*                      (C) Pisoft 1991                             *
;*                          Pavel Pisa Praha                        *
;********************************************************************

$NOLIST
$INCLUDE(CONFIG.H)
$INCLUDE(%INCH_AI)
$INCLUDE(%INCH_ADR)
$INCLUDE(%INCH_TTY)
$INCLUDE(%INCH_ULAN)
$INCLUDE(%INCH_UF)
$LIST


EXTRN  CODE(RES_STAR)
EXTRN  CODE(SFABS,INADCD,DAC_INIT,INADC1,INADC,ITIM_R)
EXTRN  XDATA(ABS,ABSTXT,ABSFL,ABSZER,FILTNUM,ADC_ACH,GLO_AUFS)
EXTRN  XDATA(VALFADC,SCNFL,SCNPTR,SCNBUF)
EXTRN  DATA(AKUM)
EXTRN  CODE(S_W_LEN,I_W_LEN,SF_INIT,S_LAMP,S_AUX)
EXTRN  DATA(F_W_LEN,A_W_LEN)
EXTRN  XDATA(R_W_LEN,AUXUAL,TIME,TIMR3)
EXTRN  BIT(ALRM_BB,PR_ENDC,PR_ENDD,uLE_ABS,SNC_ERR)
EXTRN  CODE(LAN_INI,LAN_MRK)

EXTRN  CODE(MONITOR)

PROGRAM XDATA 09000H
PROGR_E XDATA 0C000H

PUBLIC  WR_UPDA,WR_MASK

PUBLIC START,I_TIME
PUBLIC U_TIME,U_AUX,U_ABS,U_WLEN

PUBLIC  WRT_1,ERR_CRY,HELP_HL,LNT_DIR,LNT_MAX
PUBLIC  PROGRAM,PROGR_E
PUBLIC  IC_ZERR,FND_WLE,SUB_WLE,ZER_TAB,S_ZERO

SF____C SEGMENT CODE
;SF____D SEGMENT DATA
SF____B SEGMENT DATA BITADDRESSABLE
SF____X SEGMENT XDATA

CSEG    AT    00009H
EPRCHK1:DW    00000H          ; Kontrolni soucet eprom
CSEG    AT    00019H
EPRCHK2:DW    0FFFFH          ; CPL kontrolniho soucetu eprom

RSEG SF____B

WR_MASK:DS    1               ; Maska vypisu
M_F_LIN BIT   WR_MASK.7
M_TIME  BIT   WR_MASK.6
M_ABS   BIT   WR_MASK.5
M_WLEN  BIT   WR_MASK.4
M_AUX   BIT   WR_MASK.3
M_CYCLE BIT   WR_MASK.2
M_xxxx  BIT   WR_MASK.1

WR_UPDA:DS    1               ; Update flagy
U_F_LIN BIT   WR_UPDA.7
U_TIME  BIT   WR_UPDA.6
U_ABS   BIT   WR_UPDA.5
U_WLEN  BIT   WR_UPDA.4
U_AUX   BIT   WR_UPDA.3
U_CYCLE BIT   WR_UPDA.2
U_xxxx  BIT   WR_UPDA.1

RSEG SF____X

IC_DATA:           ; Udaje pro cas 0.00
IC_DAUF:DS    1    ; Attenuator
IC_DTAU:DS    1    ; Tau
IC_DWLE:DS    2    ; Wavelength
IC_DAAX:DS    1    ; AUX
IC_ZERR:DS    1    ; Pouzite typy nulovani a mark
;  1 .. multi 2 .. blank
; 10 .. scan 20 .. mark 40 .. redy 80 .. error
ZER_TAB:DS    2    ; Ukazatel na nulovaci tabulku

CHN_TMP:
BLK_RUN:DS    1    ; !=0 -> Cyklus nacitani blanku

TMP_WLE:DS    2    ; Uchovani vlnove delky

CYCLE_A:DS    2    ; Cislo cyklu
CYCLE:  DS    2    ; Pocet cyklu

ALRM_TM:DS    2    ; Cas programoveho budiku

RSEG    SF____C
	JMP   RES_STAR

; ==========================================================================
;
;       Hlavni vstup do programu spektrofotometru

START:	MOV   DPTR,#TIME      ; Inicializace casu
	CLR   A
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  @DPTR,A
	MOV   DPTR,#SCNBUF    ; Vysilani scanu
	MOVX  @DPTR,A
	MOV   DPTR,#CYCLE     ; Inicializace cyklu
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  @DPTR,A
	MOV   DPTR,#ALRM_TM   ; Casovac vypnut
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  @DPTR,A
	CLR   ALRM_BB
	CALL  CLR_ZER
	MOV   DPTR,#ABSTXT    ; Nulovani vystupu ABS
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  @DPTR,A
	MOV   DPTR,#ABSFL
	MOV   A,#ZER
	MOVX  @DPTR,A
	MOV   DPTR,#SCNFL
	CLR   A
	MOVX  @DPTR,A

	CLR   A               ; Check sum pameti EPROM
	MOV   DPL,A
	MOV   DPH,A
	MOV   R4,A
	MOV   R5,A
	MOV   R3,A
	MOV   R0,A
	MOV   R1,#07FH
START1: MOVX  A,@DPTR
	MOV   R2,A
	CALL  ADDi
	INC   DPTR
	DJNZ  R0,START1
	DJNZ  R1,START1
	MOV   DPTR,#EPRCHK1
	CALL  cLDR23i
	CALL  CMPi
	SETB  EA              ; ++++++++++++++++++
	JZ    START2
	MOV   DPTR,#ERR_EPR
	CALL  cPRINT
	MOV   A,#LCD_HOM+040H
	CALL  LCDWCOM
	MOV   R7,#50H
	CALL  PRINTi
	CALL  SCANKEY
	JZ    START

START2: CALL  LAN_INI
	CALL  FND_PGE
	MOV   DPTR,#PROG_SF
	MOVX  A,@DPTR
	XRL   A,#0AAH
	JZ    START5
	DEC   A
	JNZ   START3
	MOV   DPTR,#DATA_CH
	MOVX  A,@DPTR
	JZ    START5

START3: MOV   DPTR,#ERR_SRD   ; Zboreni SRAM
	CALL  ERR_DPT
	CALL  M_MCLR
	MOV   DPTR,#FILTNUM
	MOV   A,#2            ; Filtr
	MOVX  @DPTR,A
	MOV   DPTR,#GLO_AUFS
	MOV   A,#9
	MOVX  @DPTR,A

	MOV   DPTR,#R_W_LEN   ; Vlnova delka
	MOV   A,#LOW (2*240)
	MOVX  @DPTR,A
	INC   DPTR
	MOV   A,#HIGH (2*240)
	MOVX  @DPTR,A

START4: CALL  SET_PROG
	MOV   DPTR,#PROGRAM
	MOVX  A,@DPTR
	JZ    START5
	MOV   DPTR,#T_ST_01
	CALL  QUES_YN
	JZ    START6
START5: CALL  SET_PROG
	CALL  M_KEND
START6: CALL  I_W_LEN
	JNB   SNC_ERR,START7
	MOV   DPTR,#ERR_SNC
	CALL  cPRINT
	MOV   A,#0FFH
	CALL  WAIT_P
START7:	MOV   DPTR,#SFVER_T
	CALL  cPRINT
	MOV   A,#0FFH
	CALL  WAIT_P

SET_DIT1:MOV  R2,#LOW DIT_1
	MOV   R3,#HIGH DIT_1
	CALL  SET_DIT

; Prejde do editace programu

PROG_INV:CALL CLR_ZER
	JMP   PROG_IN

CLR_ZER:MOV  DPTR,#ZER_TAB
	CLR   A
	MOV   C,EA
	CLR   EA
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  @DPTR,A
	MOV  DPTR,#SCNPTR
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  @DPTR,A
	MOV   EA,C
	RET

; Prejde do manualniho modu
; POZOR : sp=sp-2

PROG_OU:CALL  COMP_PP         ; Kompilace programu
	POP   ACC
	POP   ACC
	CLR   %PROG_FL
	CALL  LEDWR
	JMP   SET_DIT1

; Kompilace dat

COMP_PR:MOV   DPTR,#PROG_SF
	MOVX  A,@DPTR
	XRL   A,#0AAH
	JNZ   COMP_PP
	JMP   COMP_R1
COMP_PP:MOV   DPTR,#T_PR_CO
	CALL  cPRINT
	MOV   WR_UPDA,#0FFH
COMP_P0:CALL  GO_PRBE
	MOV   DPTR,#PROG_SF
	MOV   A,#0ABH
	MOVX  @DPTR,A
	MOV   DPTR,#IC_DATA
	MOV   A,#0FFH
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  @DPTR,A
	INC   DPTR
	MOV   A,#6
	CALL  NUL_SPC
	CALL  FND_PGE
	MOV   R2,#1
	CALL  INS_SP0
	JB    F0,COMP_P1
	INC   DPTR
	MOV   R4,DPL
	MOV   R5,DPH
	MOV   DPTR,#ZER_TAB
	CALL  xSVR45i

COMP_P1:MOV   R1,#0           ; Aux output
	MOV   R2,#NOT 0
	MOV   R3,#2
	CALL  TST_LIN
	JNZ   COMP_P2
	MOV   A,R2
	ORL   A,R3
	JNZ   COMP_P2
	MOVX  A,@DPTR
	MOV   DPTR,#IC_DAAX
	MOVX  @DPTR,A
COMP_P2:MOV   R1,#0           ; Attenuator
	MOV   R2,#NOT 0
	MOV   R3,#5
	CALL  TST_LIN
	JNZ   COMP_P3
	MOV   A,R2
	ORL   A,R3
	JNZ   COMP_P3
	MOVX  A,@DPTR
	MOV   DPTR,#IC_DAUF
	MOVX  @DPTR,A
COMP_P3:MOV   R1,#0           ; Tau
	MOV   R2,#NOT 0
	MOV   R3,#6
	CALL  TST_LIN
	JNZ   COMP_P4
	MOV   A,R2
	ORL   A,R3
	JNZ   COMP_P4
	MOVX  A,@DPTR
	MOV   DPTR,#IC_DTAU
	MOVX  @DPTR,A
COMP_P4:MOV   R1,#0           ; Zerro
	MOV   R2,#NOT 0
	MOV   R3,#4
	CALL  TST_LIN
	JNZ   COMP_P5
	MOVX  A,@DPTR
	MOV   R1,A
	CALL  COM_WLO
COMP_P5:MOV   R1,#0           ; Wavelength
	MOV   R2,#NOT 0
	MOV   R3,#3
	CALL  TST_LIN
	JNZ   COMP_P7
	CALL  xLDR45i
	MOV   A,R2
	ORL   A,R3
	JNZ   COMP_P6
	MOV   DPTR,#IC_DWLE
	CALL  xSVR45i
COMP_P6:CALL  COM_WLE
COMP_P7:MOV   R1,#0           ; Mark
	MOV   R2,#NOT 0
	MOV   R3,#7
	CALL  TST_LIN
	JNZ   COMP_P8
	MOV   R1,#20H
	CALL  COM_WLO

COMP_P8:MOV   R1,#0           ; Scan
	MOV   R2,#NOT 0
	MOV   R3,#8
	CALL  TST_LIN
	JNZ   COMP_P9
	CALL  CO_SCAN
	MOV   R1,#10H
	CALL  COM_WLO
COMP_P9:
	MOV   R2,#NOT 0       ; End programu
	MOV   R3,#1
	CALL  TST_LIN
	JZ    COMP_R1
	CALL  NEXT_LN
	JZ    COMP_R1
	CALL  SET_LAD
	JMP   COMP_P1

COMP_R1:MOV   DPTR,#PROG_SF
	MOV   A,#0AAH
	MOVX  @DPTR,A
	MOV   DPTR,#IC_ZERR
	MOVX  A,@DPTR
	ANL   A,#80H
	JZ    COMP_RE
	MOV   DPTR,#T_ER_CO
	CALL  ERR_DPB
COMP_RE:RET

CO_SCAN:PUSH  DPL
	PUSH  DPH
	INC   DPTR
	INC   DPTR
	CALL  xLDR45i
CO_SCA1:CALL  COM_WLE
	JB    F0,CO_SCA3
	POP   DPH
	POP   DPL
	PUSH  DPL
	PUSH  DPH
	CALL  xLDR23i
	MOV   A,R2
	ORL   A,R3
	JNZ   CO_SCA2
	MOV   R2,#1
	CALL  DECDPTR
	CALL  DECDPTR
	CALL  xSVR23i
CO_SCA2:CALL  ADDi
	INC   DPTR
	INC   DPTR
	CALL  xLDR23i
	CALL  CMPi
	JZ    CO_SCA1
	JC    CO_SCA1
CO_SCA3:MOV   DPTR,#TMP_WLE
	CALL  xLDR45i
	POP   DPH
	POP   DPL
	MOV   A,#6
	CALL  ADDATDP
	CALL  xSVR45i
	RET

COM_WLE:MOV   DPTR,#TMP_WLE
	CALL  xSVR45i
	CALL  FND_WL0
	JB    F0,COM_WL1
	JZ    COM_WLR
	MOV   A,R6
	MOV   R4,A
	MOV   A,R7
	MOV   R5,A
	SJMP  COM_WL2
COM_WL1:JZ    COM_WLF
	MOV   DPTR,#PROG_EN
	CALL  xLDR45i
COM_WL2:MOV   R2,#6
	CALL  INS_SP0
	JB    F0,COM_WLF
	MOV   R0,DPL
	MOV   R1,DPH
	MOV   DPTR,#TMP_WLE
	CALL  xLDR45i
	MOV   DPL,R0
	MOV   DPH,R1
	CALL  xSVR45i
	INC   DPTR
	INC   DPTR
	MOV   A,#0FFH
	MOVX  @DPTR,A
COM_WLR:RET

COM_WLF:MOV   R1,#80H
COM_WLO:MOV   DPTR,#IC_ZERR
	MOV   C,EA
	CLR   EA
	MOVX  A,@DPTR
	ORL   A,R1
	MOVX  @DPTR,A
	MOV   EA,C
	RET

; Najde vlnovou delku podle R45 v [ZER_TAB]
; [DPTR]  ZERRO
; [R67]   WLEN
; [R01]   last WLEN
; R23     WLEN
; F0 a A=0 .. Err; F0 a A=1 nulovy pocet; F0 a A=2 za koncem
; A=0 nalezeno

FND_WLE:MOV   DPTR,#PROG_SF
	MOVX  A,@DPTR
	XRL   A,#0AAH
	JNZ   FND_WL4
FND_WL0:CLR   F0
	MOV   DPTR,#ZER_TAB
	CALL  xMDPDP
	MOV   A,DPL
	MOV   R6,A
	MOV   R7,DPH
	ORL   A,R7
	JZ    FND_WL4
	CLR   A
	CALL  SUB_WLE
	MOV   A,#1
	JC    FND_WL4
FND_WL1:CALL  xLDR23i
	CALL  CMPi
	JZ    FND_WL5
	JNC   FND_WL2         ; Zalezi na smeru
	MOV   A,#6*8
	CALL  SUB_WLE
	JNC   FND_WL1
FND_WL2:CALL  SUB_WL1
FND_WL3:CALL  xLDR23i
	CALL  CMPi
	JZ    FND_WL5
	CPL   C               ; Zalezi na smeru
	JC    FND_WL5
	MOV   A,#6
	CALL  SUB_WLE
	JNC   FND_WL3
	MOV   A,#2
FND_WL4:SETB  F0
FND_WL5:RET

SUB_WLE:XCH   A,R6
	MOV   R0,A
	ADD   A,R6
	MOV   R6,A
	MOV   A,R7
	MOV   R1,A
	ADDC  A,#0
	MOV   R7,A
	MOV   DPTR,#PROG_EN
	MOVX  A,@DPTR
	SETB  C
	SUBB  A,R6
	INC   DPTR
	MOVX  A,@DPTR
	SUBB  A,R7
	JNC   SUB_WLR
SUB_WL1:MOV   A,R0
	MOV   R6,A
	MOV   A,R1
	MOV   R7,A
SUB_WLR:MOV   DPL,R6
	MOV   DPH,R7
	RET

; Spusteni multi zero v manualnim modu

M_MWZER:CALL  COMP_PR
S_MWZER:MOV   R1,#MWZER       ; Zerro multiwavelength
	CALL  S_ZERO1
	MOV   DPTR,#IC_ZERR
	MOV   C,EA
	CLR   EA
	MOVX  A,@DPTR
	ORL   A,#40H
	MOVX  @DPTR,A
	MOV   EA,C
	RET

; Spusteni scanu v manualnim modu

M_SCAN: MOV   DPTR,#PROG_SF
	MOVX  A,@DPTR
	XRL   A,#0AAH
	JNZ   M_SCAN3
	CALL  GO_PRBE
M_SCAN1:MOV   R1,#0           ; Scan
	MOV   R2,#NOT 0
	MOV   R3,#8
	CALL  TST_LIN
	JZ    M_SCAN2
	CALL  NEXT_LN
	JZ    M_SCAN3
	CALL  SET_LAD
	JMP   M_SCAN1
M_SCAN2:MOV   R4,DPL
	MOV   R5,DPH
	MOV   DPTR,#IC_ZERR
	MOVX  A,@DPTR
	ANL   A,#40H
	MOV   DPTR,#T_ER_SZ
	JZ    M_SCAN4
	MOV   C,EA
	CLR   EA
	MOV   DPTR,#SCNPTR
	CALL  xSVR45i
	MOV   DPTR,#SCNFL
	MOV   A,#1
	MOVX  @DPTR,A
	MOV   EA,C
	RET
M_SCAN3:MOV   DPTR,#T_ER_SC
M_SCAN4:CALL  ERR_DPT
RUN_PRR:RET

; Vyslani znacky

M_MARK: JMP   LAN_MRK

; Spusteni nacitani nuly

RUN_BLK:MOV   A,#1
	DB    078H            ; MOV R0,#nn

; Spusteni casoveho programu

RUN_PRG:CLR   A
	MOV   DPTR,#BLK_RUN
	MOVX  @DPTR,A
	CALL  COMP_PR
	MOV   DPTR,#EPRCHK1
	CALL  cLDR23i
	MOV   DPTR,#EPRCHK2
	CALL  xLDR45i
	CALL  ADDi
	ANL   A,R4
	CPL   A
	JNZ   RUN_PRR

	CLR   PR_ENDC
	CALL  M_KEND0
	CALL  SET_CYC
	SETB  %RUN_FL
	CALL  LEDWR
	MOV   R2,#LOW  DIT_R1
	MOV   R3,#HIGH DIT_R1
	JMP   SET_DIT

; Nastaveni cycle

SET_CYC:MOV   DPTR,#CYCLE
	CALL  xLDR45i
	ORL   A,R4
	JNZ   SET_CY1
	MOV   A,#1
	MOVX  @DPTR,A
SET_CY1:MOV   DPTR,#CYCLE_A
	MOV   A,#1
	MOVX  @DPTR,A
	INC   DPTR
	CLR   A
	MOVX  @DPTR,A
SET_CY2:MOV   DPTR,#TIME
	MOV   A,#0FFH
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  @DPTR,A
	JMP   GO_PRBE

; Nastaveni pocatecnich parametru

M_KEND: CALL  COMP_PR
M_KEND0:CALL  M_KENDS
	MOV   WR_UPDA,#0FFH
;	CALL  S_LAMP  R45i
;       CALL  S_ZERRO
M_KEND1:CALL  S_W_ZER
	CALL  S_TAU
	CALL  LEDWR
	MOV   DPTR,#IC_DAAX
	MOVX  A,@DPTR
	MOV   R4,A
	JMP   S_AUX

M_KENDS:MOV   DPTR,#SCNFL
	CLR   A
	MOVX  @DPTR,A
	MOV   DPTR,#IC_DAUF
	MOVX  A,@DPTR
	INC   A
	JZ    M_KENDT
	DEC   A
	MOV   DPTR,#GLO_AUFS
	MOVX  @DPTR,A
M_KENDT:MOV   DPTR,#IC_DTAU
	MOVX  A,@DPTR
	INC   A
	JZ    M_KENDU
	DEC   A
	MOV   DPTR,#FILTNUM
	MOVX  @DPTR,A
M_KENDU:MOV   DPTR,#IC_DWLE
	CALL  xLDR45i
	MOV   A,R4
	ORL   A,R5
	JZ    M_KENDV
	MOV   DPTR,#R_W_LEN
	CALL  xSVR45i
M_KENDV:RET

; Preruseni behu programu

RU_BRK: MOV   DPTR,#T_RU_BR
	CALL  QUES_YN
	JNZ   RU_BRK1
RU_BRKR:RET
RU_BRK1:POP   ACC
	POP   ACC
RU_BRK2:CLR   %RUN_FL
	CALL  M_KEND0
	CALL  LEDWR
	JMP   SET_DIT1

RU_CH_R:JNB   %RUN_FL,RU_BRK2
	CALL  INPUTc1
	JNB   %RUN_FL,RU_BRK2
	JMP   RD_RET

RU_IT_R:JNB   %RUN_FL,RU_BRK2
	JMP   R_INTEG

CYC_NEW:SETB  U_CYCLE
	MOV   DPTR,#CYCLE_A
	CLR   A
	CLR   EA
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  @DPTR,A
	INC   DPTR
	CALL  xSVR45i
	SETB  EA
	RET

; Vyber programu

SEL_PRG:CALL  CLR_ZER
	CALL  SET_PROG
	CALL  TST_PRG
	CALL  COMP_PP         ; Kompilace programu
	POP   ACC
	POP   ACC
	JMP   SET_DIT1

; Preamp test

R_PRET: CLR   A
	MOV   DPTR,#CHN_TMP
	MOVX  @DPTR,A
R_PRET1:MOV   DPTR,#CHN_TMP
	MOVX  A,@DPTR
	RL    A
	MOV   DPTR,#PRET_T
	CALL  ADDATDP
	CALL  xLDR23i
	CALL  S_ADCAC
	MOV   WR_UPDA,#0FFH
	CALL  INPUTc1
	MOV   DPTR,#CHN_TMP
	CJNE  A,#K_UP,R_PRET2
	MOVX  A,@DPTR
	INC   A
	MOVX  @DPTR,A
	CJNE  A,#6,R_PRET1
	SJMP  R_PRET
R_PRET2:CJNE  A,#K_DOWN,R_PRET4
	MOVX  A,@DPTR
	JNZ   R_PRET3
	MOV   A,#6
R_PRET3:DEC   A
	MOVX  @DPTR,A
	SJMP  R_PRET1
R_PRET4:PUSH  ACC
	MOV   R2,#SFABSRQ
	MOV   R3,#0
	CALL  S_ADCAC
	POP   ACC
	JMP   RD_RET

S_ADCAC:MOV   A,R2
	MOV   DPTR,#ADC_ACH
	MOVX  @DPTR,A
	MOV   DPTR,#ABSFL
	MOV   A,R3
	ORL   A,#ADC_NR
	MOVX  @DPTR,A
	RET

PRET_T: DB    SFABSRQ,0
	DB    INADCRQ,0
	DB    INADCRQ+040H,0
	DB    INADCRQ+080H,0
	DB    INADCRQ+0C0H,0
	DB    SFABSRQ+0C0H,0

; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

$NOLIST

M_MODE: MOV   R4,#LOW M_M_NH
	MOV   R5,#HIGH M_M_NH
	MOV   DPTR,#HLP_TXT
	CALL  xSVR45i
	MOV   R2,#LOW  M_MOMM1
	MOV   R3,#HIGH M_MOMM1
	JMP   SET_MENU

M_MOMM1:DB    LOW M_MOMT1,HIGH M_MOMT1
	DB    LOW M_MOMH1,HIGH M_MOMH1
	DB    LOW SFT_0,HIGH SFT_0
	DB    LOW DIT_1,HIGH DIT_1
	DB    LOW SET_DIT,HIGH SET_DIT
	DB    0,0
	DB    LOW LOOP_PS,HIGH LOOP_PS
	DB    14H,15H
	DB    LOW MONITOR,HIGH MONITOR
	DB    0,0
	DB    LOW M_PSPD,HIGH M_PSPD
	DB    0,0
	DB    LOW M_MCLR,HIGH M_MCLR
	DB    LOW DIT_4,HIGH DIT_4
	DB    LOW SET_DIT,HIGH SET_DIT
	DB    0,0
	DB    LOW uL_CALL,HIGH uL_CALL
	DB    LOW DIT_6,HIGH DIT_6
	DB    LOW SET_DIT,HIGH SET_DIT
	DB    0,0
	DB    LOW M_MWZER,HIGH M_MWZER
	DB    0,0
	DB    LOW M_SCAN,HIGH M_SCAN
	DB    0,0
	DB    LOW RUN_BLK,HIGH RUN_BLK
	DB    0,0
	DB    LOW M_MOSOF,HIGH M_MOSOF
	DB    0,0
	DB    LOW M_MOSON,HIGH M_MOSON

	DB    0FEH,0FEH,0FEH
M_MOMT1:DB    0,0FFH,1
	DB    0FFH,0FFH,0FFH
	DB    'Exit',0
	DB    1,0FFH,1
	DB    0FFH,0FFH,0FFH
	DB    'Hw test',0
	DB    2,0FFh,1,0FFH,0FFH,0FFH
	DB    'Monitor',0
	DB    3,0FFh,1,0FFH,0FFH,0FFH
	DB    'Processor speed',0
	DB    4,0FFh,1,0FFH,0FFH,0FFH
	DB    'Memory clear',0
	DB    5,0FFh,1,0FFH,0FFH,0FFH
	DB    'Comunication',0
	DB    6,0FFh,1,0FFH,0FFH,0FFH
	DB    'uL Function',0
	DB    7,0FFh,1,0FFH,0FFH,0FFH
	DB    'User timer/alarm',0
	DB    8,0FFh,1,0FFH,0FFH,0FFH
	DB    'Multi wave zero',0
	DB    9,0FFh,1,0FFH,0FFH,0FFH
	DB    'Proceed scaning',0
	DB    10,0FFh,1,0FFH,0FFH,0FFH
	DB    'Run blank',0
	DB    11,0FFh,1,0FFH,0FFH,0FFH
	DB    'Pwr sync OFF',0
	DB    12,0FFh,1,0FFH,0FFH,0FFH
	DB    'Pwr sync ON',0
	DB    0FEH,0FEH,0FEH

M_MOMH1:DB    0FFH,0FFH,0FFH
	DB    'Select function',0
	DB    0FFH,0FFH,0FFH
	DB    'by cursors and',0
	DB    0FFH,0FFH,0FFH
	DB    'ENTER',0
	DB    0FEH,0FEH,0FEH

M_MCLRT:DB    C_CLR,'Clear all data?',0

M_MCLR: MOV   DPTR,#M_MCLRT
	CALL  QUES_YN
	JNZ   M_MCLR1
	RET
M_MCLR1:CLR   EA
	MOV   DPTR,#08000H
	MOV   R4,#000H
	MOV   R5,#0F8H
M_MCLR2:CLR   A            ; !!!!!!!!!!!!!!
	MOVX  @DPTR,A
	INC   DPTR
	MOV   A,R5
	XRL   A,DPH
	JNZ   M_MCLR2
	MOV   A,R4
	XRL   A,DPL
	JNZ   M_MCLR2
	MOV   DPTR,#PROG_SF
	MOV   A,#0ABH
	MOVX  @DPTR,A
	JMP   RESET

M_PSPD: MOV   DPTR,#T_MOHW1
	CALL  cPRINT
M_PSPD1:MOV   A,#LCD_HOM+048H
	CALL  LCDWCOM
	MOV   DPTR,#TIMR3
	MOV   A,#0FFH
	MOVX  @DPTR,A
	CLR   A
	MOV   R0,A
	MOV   R4,A
	MOV   R5,A
M_PSPD2:MOV   R1,#003H
M_PSPD3:DJNZ  R0,M_PSPD3
	DJNZ  R1,M_PSPD3
	MOV   A,R4
	ADD   A,#001H
	MOV   R4,A
	MOV   A,R5
	ADDC  A,#000H
	MOV   R5,A
	CALL  SCANKEY
	JNZ   M_PSPDR
	MOV   DPTR,#TIMR3
	MOVX  A,@DPTR
	JNZ   M_PSPD2
	MOV   R7,#070H
	CALL  PRINTi
	CALL  SCANKEY
	JZ    M_PSPD1
M_PSPDR:MOV   WR_UPDA,#0FFH
	RET

uL_CALL:MOV  WR_MASK,#0
	MOV  DPTR,#uL_CALT
	CALL cPRINT
	MOV  R6,#041H
	MOV  R7,#030H
	CALL INPUTi
	MOV  A,R4
	PUSH ACC
	MOV  R6,#048H
	MOV  R7,#050H
	CALL INPUTi
	POP  ACC
	MOV  R0,A
	MOV  A,R4
	MOV  DPTR,#1234H
	JMP  uL_FNC

M_MORUN:MOV   DPTR,#TIME
	CLR   A
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  @DPTR,A
	SETB  M_TIME
	SETB  U_TIME
	RET

M_MOSON:CLR   EX1
	SETB  EX0
	RET

M_MOSOF:CLR   EX0
	SETB  EX1
	RET

uL_CALT:DB   LCD_CLR,'Function Param',0
T_MOHW1:DB   LCD_CLR,'Speed in ',0F7H,'stones',0
T_MOHW2:DB   LCD_CLR,'Service mode'
	DB   C_LIN2 ,0

LOOP_PS:POP   ACC
	POP   ACC
	MOV   A,#LCD_CLR
	CALL  LCDWCOM
	MOV   WR_MASK,#0
LOOP:   CALL  MOT_PRT
	MOV   A,#LCD_HOM
	CALL  LCDWCOM
	MOV   DPTR,#ADC_ACH
	MOVX  A,@DPTR
	JB    ACC.0,LOOP1
	CALL  WR_ABS
	JMP   LOOP2
LOOP1:  CALL  WR_HXAD
LOOP2:  CALL  SCANKEY
	JZ    LOOP
	MOV   R7,A
	MOV   A,#LOW LOOP
	PUSH  ACC
	MOV   A,#HIGH LOOP
	PUSH  ACC
	MOV   DPTR,#SFT_SP
	JMP   SEL_FN2

SFT_SP: DB    K_PROG
	DB    0,0
	DB    LOW RESET,HIGH RESET

	DB    K_MODE
	DB    0,0
	DB    LOW SFP_RET,HIGH SFP_RET

	DB    K_RUN
	DB    0,0
	DB    LOW INADC1,HIGH INADC1

	DB    K_INS
	DB    0,0
	DB    LOW I_W_LEN,HIGH I_W_LEN

	DB    K_CYCLE
	DB    0,0
	DB    LOW S_W_LEN,HIGH S_W_LEN

	DB    K_0
	DB    INADCRQ,0
	DB    LOW S_ADCAC,HIGH S_ADCAC

	DB    K_END
	DB    0,0
	DB    LOW S_ADCAC,HIGH S_ADCAC

	DB    K_ABS
	DB    SFABSRQ,0
	DB    LOW S_ADCAC,HIGH S_ADCAC

	DB    K_1
	DB    INADCRQ+040H,0
	DB    LOW S_ADCAC,HIGH S_ADCAC

	DB    K_2
	DB    INADCRQ+080H,0
	DB    LOW S_ADCAC,HIGH S_ADCAC

	DB    K_3
	DB    INADCRQ+0C0H,0
	DB    LOW S_ADCAC,HIGH S_ADCAC

	DB    K_DOWN
	DB    0FFH,0FFH
	DB    LOW SFP_WLEN,HIGH SFP_WLEN

	DB    K_UP
	DB    1,0
	DB    LOW SFP_WLEN,HIGH SFP_WLEN

	DB    K_AUX
	DB    0,0
	DB    LOW SFP_SWH,HIGH SFP_SWH

	DB    0FFH
	DB    LOW SFT_SP0,HIGH SFT_SP0

SFP_WLEN:MOV  DPTR,#R_W_LEN
	CALL  xLDR45i
	CALL  ADDi
	CALL  xSVR45i
	JMP   S_W_LEN

SFP_RET:MOV   R2,#SFABSRQ
	MOV   R3,#0
	CALL  S_ADCAC
	MOV   SP,#048H
	JMP   SET_DIT1

SFP_SWH:MOV   DPTR,#ADC_ACH
	MOV   C,EA
	CLR   EA
	MOVX  A,@DPTR
	XRL   A,#001H
	MOVX  @DPTR,A
	MOV   EA,C
	RET

WR_HXAD:MOV   DPTR,#VALFADC+2
	MOVX  A,@DPTR
	CALL  WRHEX
	CALL  DECDPTR
	MOVX  A,@DPTR
	CALL  WRHEX
	CALL  DECDPTR
	MOVX  A,@DPTR
	CALL  WRHEX
	MOV   A,#' '
	JMP   LCDWR

WRHEX:  MOV   R2,A
	RL    A
	RL    A
	RL    A
	RL    A
	CALL  WRNIB
	MOV   A,R2
WRNIB:  ANL   A,#00FH
	ADD   A,#0F6H
	JNC   WRNIB1
	ADD   A,#07
WRNIB1: ADD   A,#03AH
	JMP   LCDWR

MOT_PRT:MOV   A,#LCD_HOM+8
	CALL  LCDWCOM
	MOV   A,P1
	CALL  WRHEX
	MOV   A,#LCD_HOM+048H
	CALL  LCDWCOM
	MOV   DPTR,#MOTOR
	MOVX  A,@DPTR
	CALL  WRHEX
	MOV   A,#LCD_HOM+040H
	CALL  LCDWCOM
	MOV   R7,#0B0H
	MOV   R4,A_W_LEN
	MOV   R5,A_W_LEN+1
	CALL  PRINTi
	MOV   A,#' '
	CALL  LCDWR
	MOV   A,F_W_LEN
	CALL  WRHEX
	MOV   A,#LCD_HOM+00EH
	CALL  LCDWCOM
	MOV   DPTR,#TIME
	MOVX  A,@DPTR
	CALL   WRHEX
	MOV   A,#LCD_HOM+00BH
	CALL  LCDWCOM
	MOV   A,01EH
	JMP   WRHEX


; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

$LIST
I_TIMM :MOV   DPTR,#TIME      ; Manualni rezim
	CALL  xLDR23i
	MOV   DPTR,#ALRM_TM
	CALL  xLDR45i
	ORL   A,R4
	JZ    I_TIMEC
	CALL  CMPi
	JZ    I_TIMM1
	JNC   I_TIMEC
I_TIMM1:SETB  ALRM_BB
	CLR   A
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  @DPTR,A
	JMP   I_TIMEC

I_TI_PE:SETB  PR_ENDD
	CLR   %RUN_FL
I_TIMEC:JMP   ITIM_R

; Vstup casoveho preruseni

I_TIME:	JNB   %RUN_FL,I_TIMM
	JB    PR_ENDC,I_TIMEC
	MOV   DPTR,#TIME
	CALL  xLDR23i
	ORL   A,R2
	JZ    I_TI_PR

I_TI_PR:MOV   DPTR,#TIME
	CALL  xLDR45i
	CALL  GET_LAD
	MOVX  A,@DPTR
	JZ    I_TIMEC
	INC   DPTR
	MOVX  A,@DPTR
	MOV   R1,A
	ANL   A,#03FH
	JZ    I_TIMEC
	INC   DPTR
	CALL  xLDR23i
	CALL  CMPi
	JC    I_TIMEC
	CJNE  R1,#1,I_TI_P1   ; End programu
	CALL  M_KENDS
	CALL  M_KEND1
	MOV   DPTR,#BLK_RUN   ; Pouze 1. cyklus blank
	CLR   A
	MOVX  @DPTR,A
	MOV   DPTR,#CYCLE_A   ; Zvyseni pocitadla cyklu
	MOVX  A,@DPTR
	INC   A
	MOVX  @DPTR,A
	MOV   R2,A
	INC   DPTR
	JNZ   I_TI_E1
	MOVX  A,@DPTR
	INC   A
	MOVX  @DPTR,A
I_TI_E1:MOVX  A,@DPTR
	MOV   R3,A
	INC   DPTR
	CALL  xLDR45i
	CALL  CMPi
	JNC   I_TI_E2
	CLR   M_CYCLE
	SETB  PR_ENDC
	JMP   I_TI_PE

I_TI_E2:CALL  SET_CY2         ; Dalsi cyklus
	SETB  U_CYCLE
I_TIMECV:JMP  I_TIMEC

I_TI_P1:CJNE  R1,#2,I_TI_P2   ; Aux output
	MOVX  A,@DPTR
	MOV   R4,A
	CALL  S_AUX

I_TI_P2:CJNE  R1,#3,I_TI_P3   ; Wavelength
	MOV   R4,DPL
	MOV   R5,DPH
	MOV   DPTR,#SCNFL
	MOVX  A,@DPTR
	JNZ   I_TIMECV
	MOV   DPTR,#ABSFL
	MOVX  A,@DPTR
	ANL   A,#ZER OR ZERIP OR MWZER OR MWZERIP
	JNZ   I_TIMECV
	MOV   DPL,R4
	MOV   DPH,R5
	CALL  xLDR45i
	MOV   DPTR,#R_W_LEN
	CALL  xSVR45i
	SETB  U_WLEN
	CALL  S_W_LEN
	CALL  S_W_ZE0

I_TI_P3:CJNE  R1,#5,I_TI_P4   ; Attenuator
	MOVX  A,@DPTR
	MOV   DPTR,#GLO_AUFS
	MOVX  @DPTR,A

I_TI_P4:CJNE  R1,#6,I_TI_P5   ; Tau
	MOVX  A,@DPTR
	MOV   DPTR,#FILTNUM
	MOVX  @DPTR,A
	CALL  S_TAU
	MOV   R1,#0

I_TI_P5:CJNE  R1,#4,I_TI_P8   ; Zerro
	MOVX  A,@DPTR
	INC   DPTR
	MOV   R2,DPL
	MOV   R3,DPH
	MOV   R7,A
	CJNE  R7,#1,I_TI_P6
	CALL  S_MWZER         ; Zerro multiwavelength
	SJMP  I_TI_P7
I_TI_P6:MOV   A,R7
	JZ    I_TI_Q5
	MOV   DPTR,#SCNFL
	MOVX  A,@DPTR
	JNZ   I_TIMECV
	MOV   DPTR,#BLK_RUN   ; Blank zerro
	MOVX  A,@DPTR
	JZ    I_TI_Q4
	DEC   A
	JNZ   I_TI_Q3
	MOV   A,#2
	MOVX  @DPTR,A
	CALL  S_ZERO
I_TIMECV2:JMP I_TIMEC
I_TI_Q3:MOV   DPTR,#ABSFL
	MOVX  A,@DPTR
	ANL   A,#ZER OR ZERIP OR MWZER OR MWZERIP
	JNZ   I_TIMECV2
	MOV   DPTR,#BLK_RUN
	MOV   A,#1
	MOVX  @DPTR,A
	MOV   A,R2
	MOV   R4,A
	MOV   A,R3
	MOV   R5,A
	MOV   R2,#LOW ABSZER
	MOV   R3,#HIGH ABSZER
	MOV   R0,#4
	CALL  xxMOVEt
	JMP   I_TI_P7
I_TI_Q4:MOV   R4,#LOW ABSZER
	MOV   R5,#HIGH ABSZER
	MOV   R0,#4
	CALL  xxMOVEt
	SJMP  I_TI_P7
I_TI_Q5:CALL  S_ZERO          ; Normal zerro
I_TI_P7:MOV   R1,#0

I_TI_P8:CJNE  R1,#7,I_TI_P9   ; Mark
	CALL  M_MARK
	MOV   R1,#0

I_TI_P9:CJNE  R1,#8,I_TI_PX   ; Scaning
	MOV   R4,DPL
	MOV   R5,DPH
	MOV   DPTR,#ABSFL
	MOVX  A,@DPTR
	ANL   A,#ZER OR ZERIP OR MWZER OR MWZERIP
	JZ    I_TI_P10
I_TIMECV1:JMP I_TIMEC
I_TI_P10:MOV  DPTR,#SCNPTR
	MOV   C,EA
	CLR   EA
	CALL  xSVR45i
	MOV   DPTR,#SCNFL
	MOV   A,#1
	MOVX  @DPTR,A
	MOV   R1,#0
	MOV   EA,C

I_TI_PX:CALL  NEXT_LN
	CALL  SET_LAD
	JMP   I_TI_PR

S_W_ZER:CALL  S_W_LEN
S_W_ZE0:MOV   DPTR,#IC_ZERR
	MOVX  A,@DPTR
	JNB   ACC.0,S_W_ZE1
	JNB   ACC.6,S_W_ZE1
	MOV   R1,#SWZER
	CALL  S_ZERO1
	MOV   R1,#0
S_W_ZE1:RET


; *******************************************************************

; Hlidani kritickych chyb

ERR_CRY:JB     PR_ENDD,PR_ENDO
	JB     ALRM_BB,ALRM_BE
	JBC    uLE_ABS,ABS_OER
	CLR    A
	RET

ABS_OER:MOV    DPTR,#ABS_OET
	JMP    ERR_DPB

ALRM_BE:CLR    ALRM_BB
	MOV    DPTR,#ALRM_BT
	JMP    ERR_DPB

PR_ENDO:CLR    PR_ENDD
	MOV    DPTR,#T_PREND
	JMP    ERR_DPT

; *******************************************************************

; Jednotlive vypisy na obrazovku

WR_TIME:MOV    DPTR,#TIME     ; Vypis casu
	CALL   xLDR45i        ; X.XX
	ANL    A,R4
	CPL    A
	JZ     WR_TIM2
;	JNB    HOLD_FL,WR_TIM1
;	MOV    A,R4
;	JB     ACC.0,WR_TIM2
WR_TIM1:MOV    R7,#042H
	JMP    PRINTi
WR_TIM2:MOV    DPTR,#WR_TIMT
	JMP    cPRINT
WR_TIMT:DB     '    ',0

WR_ABS: MOV    DPTR,#ABSFL
	MOVX   A,@DPTR
	MOV    DPTR,#T_ABS_1
	JB     ACC.ZER1B,WR_ABS1
	MOV    DPTR,#T_ABS_3
	JB     ACC.MWZERIPB,WR_ABS1
	MOV    DPTR,#T_ABS_2
	ANL    A,#ADC_OVR
	JNZ    WR_ABS1
	MOV    DPTR,#ABSTXT
	JMP    xPRINT

WR_ABS1:JMP    cPRINT

T_ABS_1:DB     ' Null  ',0
T_ABS_2:DB     ' Over  ',0
T_ABS_3:DB     'Null s.',0

S_TAU:  MOV    R1,#CHN_TAU
	JMP    S_ZERO1

S_ZERO: MOV    R1,#ZER
S_ZERO1:MOV    DPTR,#ADC_ACH
	MOV    A,#SFABSRQ
	MOVX   @DPTR,A
	MOV    C,EA
	CLR    EA
	MOV    DPTR,#ABSFL
	MOVX   A,@DPTR
	ORL    A,R1
	MOVX   @DPTR,A
	MOV    EA,C
	RET

WR_WLEN:MOV    A,F_W_LEN
	MOV    DPTR,#T_W_LNE
	JB     ACC.5,WR_WLE1
	MOV    DPTR,#T_W_LNI
	JB     ACC.7,WR_WLE1
	MOV    R4,A_W_LEN
	MOV    R5,A_W_LEN+1
WR_WLE0:MOV    A,#1
	CALL   SHRi
	MOV    R7,#0B0H
	JMP    PRINTi
WR_WLE1:JMP    cPRINT

T_W_LNI:DB     'Ini',0
T_W_LNE:DB     'Err',0

WR_AUX: MOV    DPTR,#AUXUAL   ; Vypis vystupu a mimo
	MOVX   A,@DPTR        ; PROG i vstupu
WR_AUX0:MOV    R0,A           ; 1234 56
	MOV    R1,#'0'
	MOV    R2,#4
	MOV    R3,#1
WR_AUX1:INC    R1
	MOV    A,R0
	RRC    A
	MOV    R0,A
	MOV    A,#'_'
	JNC    WR_AUX2
	MOV    A,R1
WR_AUX2:CALL   LCDWR
	DJNZ   R2,WR_AUX1
	JB     %PROG_FL,WR_AUXR
	DJNZ   R3,WR_AUXR
	MOV    A,#' '
	MOV    R2,#3
	JMP    WR_AUX2

WR_AUXR:RET

WR_CYCLE:
	MOV    DPTR,#CYCLE_A
	MOV    R7,#030H
	CALL   PRINTiP
	CALL   xLDR23i
	CALL   xLDR45i
	CALL   SUBi
	MOV    R7,#050H
	JMP    PRINTi

WR_CYC1:MOV    A,#LCD_HOM+40H
	CALL   LCDWCOM
	MOV    DPTR,#CYCLE
	MOV    R7,#030H
	JMP    PRINTiP

WR_AUFS:MOV    DPTR,#GLO_AUFS
	MOVX   A,@DPTR
	MOV    DPTR,#TB_AUFS
WR_AUF0:MOV    R1,A
	INC    R1
WR_AUF1:DJNZ   R1,WR_AUF2
	JMP    cPRINT
WR_AUF2:CLR    A
	MOVC   A,@A+DPTR
	JZ     WR_AUXR
WR_AUF3:CLR    A
	MOVC   A,@A+DPTR
	INC    DPTR
	JNZ    WR_AUF3
	SJMP   WR_AUF1

WR_TAU: MOV    DPTR,#FILTNUM
	MOVX   A,@DPTR
	MOV    DPTR,#TB_TAU
	SJMP   WR_AUF0

TB_AUFS:DB     '.005',0
	DB     '0.01',0
	DB     '0.02',0
	DB     '0.05',0
	DB     ' 0.1',0
	DB     ' 0.2',0
	DB     ' 0.5',0
	DB     '   1',0
	DB     '   2',0
	DB     ' -0-',0
	DB     0

TB_TAU: DB     ' F',0
	DB     '.1',0
	DB     '.2',0
	DB     '.3',0
	DB     '.5',0
	DB     ' 1',0
	DB     0

TB_SCON:DB     ' Off',0
	DB     'uLan',0
	DB     'APEX',0
	DB     0

TB_ZERR:DB     'Normal',0
	DB     '   All',0
	DB     ' Blank',0
	DB     0

WR_SCOM:MOV    A,#LCD_HOM+40H ; 'Adr kBd Mod Grp'
	CALL   LCDWCOM
	MOV    DPTR,#uL_ADR
	MOVX   A,@DPTR
	MOV    R4,A
	MOV    R5,#0
	MOV    R7,#20H
	CALL   PRINTi
	MOV    A,#LCD_HOM+43H
	CALL   LCDWCOM
	MOV    DPTR,#uL_SPD
	MOVX   A,@DPTR
	CPL    A
	INC    A
	MOV    R2,A
	MOV    R3,#0
	MOV    R4,#LOW 5760
	MOV    R5,#HIGH 5760
	CALL   DIVi
	MOV    R7,#42H
	CALL   PRINTi
	MOV    A,#LCD_HOM+4DH
	CALL   LCDWCOM
	MOV    DPTR,#uL_GRP
	MOVX   A,@DPTR
	MOV    R4,A
	MOV    R5,#0
	MOV    R7,#20H
	CALL   PRINTi
	MOV    A,#LCD_HOM+48H
	CALL   LCDWCOM
	MOV    DPTR,#uL_FORM
	MOVX   A,@DPTR
	MOV    DPTR,#TB_SCON
	JMP    WR_AUF0

WR_ALRM:CALL   LCDNBUS
	MOV    A,#LCD_HOM+45H
	CALL   LCDWCO1
	MOV    DPTR,#ALRM_TM
	MOV    R7,#42H
	JMP    PRINTiP

WR_PRET:CALL   LCDNBUS
	MOV    A,#LCD_HOM+42H
	CALL   LCDWCO1
	MOV    DPTR,#CHN_TMP
	MOVX   A,@DPTR
	MOV    DPTR,#TB_PRET
	JMP    WR_AUF0

TB_PRET:DB    'ABS1 ',0
	DB    'RAT1 ',0
	DB    'MEAS ',0
	DB    'REFER',0
	DB    'RAT2 ',0
	DB    'ABS2 ',0
	DB    0

WR_TIMP:CALL   LCDNBUS
	MOV    A,#LCD_HOM+40H
	CALL   LCDWCO1
	CALL   GET_LAD
	INC    DPTR
	INC    DPTR
	CALL   xLDR45i
	INC    DPTR
	INC    DPTR
	MOV    R7,#042H
	JMP    PRINTi

WR_P_2: CALL   WR_TIMP
	CALL   LCDNBUS
	MOV    A,#LCD_HOM+47H
	CALL   LCDWCO1
	MOVX   A,@DPTR
	JMP    WR_AUX0

WR_P_3: CALL   WR_TIMP
	CALL   LCDNBUS
	MOV    A,#LCD_HOM+47H
	CALL   LCDWCO1
WR_P_WL:CALL   xLDR45i
	INC    DPTR
	INC    DPTR
	JMP    WR_WLE0

WR_P_4: CALL   WR_TIMP
	CALL   LCDNBUS
	MOV    A,#LCD_HOM+46H
	CALL   LCDWCO1
	MOVX   A,@DPTR
	MOV    DPTR,#TB_ZERR
	JMP    WR_AUF0

WR_P_5: CALL   WR_TIMP
	CALL   LCDNBUS
	MOV    A,#LCD_HOM+47H
	CALL   LCDWCO1
	MOVX   A,@DPTR
	MOV    DPTR,#TB_AUFS
	JMP    WR_AUF0

WR_P_6: CALL   WR_TIMP
	CALL   LCDNBUS
	MOV    A,#LCD_HOM+48H
	CALL   LCDWCO1
	MOVX   A,@DPTR
	MOV    DPTR,#TB_TAU
	JMP    WR_AUF0

WR_P_8: CALL   WR_TIMP        ; Scan
	CALL   LCDNBUS
	MOV    A,#LCD_HOM+4DH ; Step
	CALL   LCDWCO1
	CALL   WR_P_WL
	CALL   LCDNBUS
	MOV    A,#LCD_HOM+45H ; Lo
	CALL   LCDWCO1
	CALL   WR_P_WL
	CALL   LCDNBUS
	MOV    A,#LCD_HOM+49H ; Hi
	CALL   LCDWCO1
	JMP    WR_P_WL

; *******************************************************************

S_W_RET:MOV    DPTR,#WR_RETB
	POP    ACC
	MOV    R3,A
	POP    ACC
	MOV    R2,A
	POP    ACC
	MOV    R1,A
	POP    ACC
	MOVX   @DPTR,A
	INC    DPTR
	MOV    A,R1
	MOVX   @DPTR,A
	MOV    DPL,R2
	MOV    DPH,R3
	CLR    A
	JMP    @A+DPTR

; *******************************************************************

LNT_DIR:DB     LOW LNT_0,HIGH LNT_0
	DB     LOW LNT_1,HIGH LNT_1
	DB     LOW LNT_2,HIGH LNT_2
	DB     LOW LNT_3,HIGH LNT_3
	DB     LOW LNT_4,HIGH LNT_4
	DB     LOW LNT_5,HIGH LNT_5
	DB     LOW LNT_6,HIGH LNT_6
	DB     LOW LNT_7,HIGH LNT_7
	DB     LOW LNT_8,HIGH LNT_8

LNT_MAX SET    9

; Typy radek programu
;
; +0  .. delka tohoto typu radky
; +1  .. pocet pozic N
; +2  .. prvni radka F_LINE
; +4  .. vypis radky DP_FLEX
; +6  .. N * ukazatel na POT

; null line - End of program
LNT_0:  DB     16,1
	DB     LOW T_PRNUL,HIGH T_PRNUL
	DB     LOW WR_RET,HIGH WR_RET
	DB     LOW POT_P0,HIGH POT_P0
; ** End **
LNT_1:  DB     4,1
	DB     LOW T_PR_1,HIGH T_PR_1
	DB     LOW WR_TIMP,HIGH WR_TIMP
	DB     LOW POT_P1,HIGH POT_P1
; Auxual outputs
LNT_2:  DB     5,2
	DB     LOW T_PR_2,HIGH T_PR_2
	DB     LOW WR_P_2,HIGH WR_P_2
	DB     LOW POT_P1,HIGH POT_P1
	DB     LOW POT_P2,HIGH POT_P2

; Wavelength
LNT_3:  DB     6,2
	DB     LOW T_PR_3,HIGH T_PR_3
	DB     LOW WR_P_3,HIGH WR_P_3
	DB     LOW POT_P1,HIGH POT_P1
	DB     LOW POT_P3,HIGH POT_P3

; Zerro
LNT_4:  DB     9,2
	DB     LOW T_PR_4,HIGH T_PR_4
	DB     LOW WR_P_4,HIGH WR_P_4
	DB     LOW POT_P1,HIGH POT_P1
	DB     LOW POT_P4,HIGH POT_P4

; Attenuator
LNT_5:  DB     5,2
	DB     LOW T_PR_5,HIGH T_PR_5
	DB     LOW WR_P_5,HIGH WR_P_5
	DB     LOW POT_P1,HIGH POT_P1
	DB     LOW POT_P5,HIGH POT_P5

; Time const.
LNT_6:  DB     5,2
	DB     LOW T_PR_6,HIGH T_PR_6
	DB     LOW WR_P_6,HIGH WR_P_6
	DB     LOW POT_P1,HIGH POT_P1
	DB     LOW POT_P6,HIGH POT_P6
; Mark
LNT_7:  DB     4,1
	DB     LOW T_PR_7,HIGH T_PR_7
	DB     LOW WR_TIMP,HIGH WR_TIMP
	DB     LOW POT_P1,HIGH POT_P1
; Scaning
LNT_8:  DB     12,4
	DB     LOW T_PR_8,HIGH T_PR_8
	DB     LOW WR_P_8,HIGH WR_P_8
	DB     LOW POT_P1,HIGH POT_P1
	DB     LOW POT_P7,HIGH POT_P7
	DB     LOW POT_P8,HIGH POT_P8
	DB     LOW POT_P9,HIGH POT_P9

LNT_9:

; Vypisy na displej

; plati pro 2.010,2.040,3.020,3.030,3.040,4.060

WRT_1  :DB     LCD_CLR,LOW WR_FLIN,HIGH WR_FLIN
	DB     LCD_HOM+040H,LOW WR_TIME,HIGH WR_TIME
	DB     LCD_HOM+049H,LOW WR_ABS,HIGH WR_ABS
	DB     LCD_HOM+040H,LOW WR_WLEN,HIGH WR_WLEN
	DB     LCD_HOM+047H,LOW WR_AUX,HIGH WR_AUX
	DB     LCD_HOM+040H,LOW WR_CYCLE,HIGH WR_CYCLE
	DB     LCD_HOM+044H,LOW WR_AUFS,HIGH WR_AUFS
	DB     LCD_HOM+00DH,LOW WR_FLEX,HIGH WR_FLEX

; Pro beh programu

WRT_2  :DB     LCD_CLR,LOW WR_FLIN,HIGH WR_FLIN
	DB     LCD_HOM+040H,LOW WR_TIME,HIGH WR_TIME
	DB     LCD_HOM+049H,LOW WR_ABS,HIGH WR_ABS
	DB     LCD_HOM+045H,LOW WR_WLEN,HIGH WR_WLEN
	DB     LCD_HOM+047H,LOW WR_AUX,HIGH WR_AUX
	DB     LCD_HOM+045H,LOW WR_CYCLE,HIGH WR_CYCLE
	DB     LCD_HOM+045H,LOW WR_AUFS,HIGH WR_AUFS
	DB     LCD_HOM+040H,LOW WR_FLEX,HIGH WR_FLEX

; Jednotlive displeje

; plati pro 2.010

DIT_1:  DB    10110011B       ; F_LINE,ABS,WLEN,AUFS,WR_FLEX(TAU)
	DB    LOW T_MABS,HIGH T_MABS
	DB    LOW WRT_1,HIGH WRT_1
	DB    LOW WR_TAU,HIGH WR_TAU
	DB    LOW POT_1,HIGH POT_1

; plati pro 2.040

DIT_2:  DB    10001000B       ; F_LINE,AUX
	DB    LOW T_MANA,HIGH T_MANA
	DB    LOW WRT_1,HIGH WRT_1
	DB    LOW WR_RET,HIGH WR_RET
	DB    LOW POT_4,HIGH POT_4

; nastaveni seriove komunikace

DIT_4:  DB    10000001B       ; F_LINE,WR_FLEX
	DB    LOW T_MSCOM,HIGH T_MSCOM
	DB    LOW WRT_1,HIGH WRT_1
	DB    LOW WR_SCOM,HIGH WR_SCOM
	DB    LOW POT_8,HIGH POT_8

; nastaveni cycle v manualnim rezimu

DIT_5:  DB    10000001B       ; F_LINE,WR_CYC1
	DB    LOW T_RUNR,HIGH T_RUNR
	DB    LOW WRT_1,HIGH WRT_1
	DB    LOW WR_CYC1,HIGH WR_CYC1
	DB    LOW POT_10,HIGH POT_10

; uzivatelsky budik

DIT_6:  DB    11000001B       ; F_LINE,WR_TIME,WR_ARLM
	DB    LOW T_ALRM,HIGH T_ALRM
	DB    LOW WRT_1,HIGH WRT_1
	DB    LOW WR_ALRM,HIGH WR_ALRM
	DB    LOW POT_11,HIGH POT_11

; vyber programu z menu

DIT_7:  DB    10000001B       ; F_LINE,WR_PROG
	DB    LOW T_PRSL,HIGH T_PRSL
	DB    LOW WRT_1,HIGH WRT_1
	DB    LOW WR_PROG,HIGH WR_PROG
	DB    LOW POT_13,HIGH POT_13

; cteni vstupu prevodniku

DIT_8:  DB    10100001B       ; F_LINE,WR_ABS,WR_PRET
	DB    LOW T_PRET,HIGH T_PRET
	DB    LOW WRT_1,HIGH WRT_1
	DB    LOW WR_PRET,HIGH WR_PRET
	DB    LOW POT_17,HIGH POT_17

; pri run vypisuje cas a cycle

DIT_R1: DB    11110000B       ; F_LINE,WR_TIME,WR_WLEN,WR_ABS
	DB    LOW T_RUNB,HIGH T_RUNB
	DB    LOW WRT_2,HIGH WRT_2
	DB    LOW WR_RET,HIGH WR_RET
	DB    LOW POT_R1,HIGH POT_R1

DIT_R2: DB    10000101B       ; F_LINE,WR_CYCLE,WR_CYC1
	DB    LOW T_RUNR,HIGH T_RUNR
	DB    LOW WRT_2,HIGH WRT_2
	DB    LOW WR_CYC1,HIGH WR_CYC1
	DB    LOW POT_R2,HIGH POT_R2

DIT_R3: DB    11001000B       ; F_LINE,WR_AUX
	DB    LOW T_RUNA,HIGH T_RUNA
	DB    LOW WRT_2,HIGH WRT_2
	DB    LOW WR_RET,HIGH WR_RET
	DB    LOW POT_R1,HIGH POT_R1

; Jednotlive pozice cursoru

; Pozice 2.011

POT_1:  DB    LOW SFT_1,HIGH SFT_1
	DB    LOW MSWL_HL,HIGH MSWL_HL
	DB    040H
	DB    LOW R_INTEG,HIGH R_INTEG
	DB    LOW R_W_LEN,HIGH R_W_LEN
	DB    LOW RT_WLEN,HIGH RT_WLEN
	DB    LOW S_W_LEN,HIGH S_W_LEN

POT_2:  DB    LOW SFT_2,HIGH SFT_2
	DB    LOW MAUF_HL,HIGH MAUF_HL
	DB    047H
	DB    LOW R_CHAR,HIGH R_CHAR
	DB    LOW GLO_AUFS,HIGH GLO_AUFS
	DB    0,0
	DB    0,0

POT_3:  DB    LOW SFT_3,HIGH SFT_3
	DB    LOW MTAU_HL,HIGH MTAU_HL
	DB    00EH
	DB    LOW R_CHAR,HIGH R_CHAR
	DB    LOW FILTNUM,HIGH FILTNUM
	DB    0,0
	DB    LOW S_TAU,HIGH S_TAU

; Pozice 2.040

POT_4:  DB    LOW SFT_4,HIGH SFT_4
	DB    LOW P2040_H,HIGH P2040_H
	DB    04AH
	DB    LOW R_CHAR,HIGH R_CHAR
	DB    LOW AUXUAL,HIGH AUXUAL
	DB    0,0
	DB    LOW S_AUX,HIGH S_AUX

POT_8:  DB    LOW SFT_8,HIGH SFT_8
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    040H
	DB    LOW R_INTEG,HIGH R_INTEG
	DB    LOW uL_ADR,HIGH uL_ADR
	DB    LOW RT_uL_A,HIGH RT_uL_A
	DB    0,0

POT_9:  DB    LOW SFT_9,HIGH SFT_9
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    046H
	DB    LOW R_CHAR,HIGH R_CHAR
	DB    LOW uL_SPD,HIGH uL_SPD
	DB    0,0
	DB    0,0

POT_10: DB    LOW SFT_0,HIGH SFT_0
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    040H
	DB    LOW R_INTEG,HIGH R_INTEG
	DB    0,0
	DB    LOW RT_CYCL,HIGH RT_CYCL
	DB    LOW CYC_NEW,HIGH CYC_NEW

POT_11: DB    LOW SFT_10,HIGH SFT_10
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    045H
	DB    LOW R_INTEG,HIGH R_INTEG
	DB    LOW ALRM_TM,HIGH ALRM_TM
	DB    LOW RT_TIME,HIGH RT_TIME
	DB    0,0

POT_12: DB    LOW SFT_11,HIGH SFT_11
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    04BH
	DB    LOW R_CHAR,HIGH R_CHAR

POT_13: DB    LOW SFT_13,HIGH SFT_13
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    042H
	DB    LOW R_CHAR,HIGH R_CHAR
	DB    LOW PROG_NU,HIGH PROG_NU
	DB    0,0
	DB    LOW SET_PROG,HIGH SET_PROG

POT_14: DB    LOW SFT_12,HIGH SFT_12
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    044H
	DB    LOW R_TEXTP,HIGH R_TEXTP
	DB    0,0
	DB    10,0
	DB    LOW SET_PROG,HIGH SET_PROG

POT_15: DB    LOW SFT_15,HIGH SFT_15
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    04BH
	DB    LOW R_CHAR,HIGH R_CHAR
	DB    LOW uL_FORM,HIGH uL_FORM
	DB    0,0
	DB    0,0

POT_16: DB    LOW SFT_14,HIGH SFT_14
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    04DH
	DB    LOW R_INTEG,HIGH R_INTEG
	DB    LOW uL_GRP,HIGH uL_GRP
	DB    LOW RT_uL_A,HIGH RT_uL_A
	DB    0,0

POT_17: DB    LOW SFT_0,HIGH SFT_0
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    045H
	DB    LOW R_PRET,HIGH R_PRET
	DB    0,0
	DB    0,0
	DB    0,0

POT_P0: DB    LOW SFT_P1,HIGH SFT_P1
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    040H
	DB    LOW R_CHAR,HIGH R_CHAR
	DB    0,0
	DB    0,0

POT_P1: DB    LOW SFT_P1,HIGH SFT_P1
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    040H
	DB    LOW R_INTEG,HIGH R_INTEG
	DB    2,0
	DB    LOW RT_TIME,HIGH RT_TIME
	DB    LOW SP_TIME,HIGH SP_TIME

POT_P2: DB    LOW SFT_P2,HIGH SFT_P2
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    04AH
	DB    LOW R_CHAR,HIGH R_CHAR
	DB    4,0
	DB    0,0
	DB    0,0

POT_P3: DB    LOW SFT_P1,HIGH SFT_P1
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    047H
	DB    LOW R_INTEG,HIGH R_INTEG
	DB    4,0
	DB    LOW RT_WLEN,HIGH RT_WLEN
	DB    0,0

POT_P4: DB    LOW SFT_P4,HIGH SFT_P4
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    04BH
	DB    LOW R_CHAR,HIGH R_CHAR
	DB    4,0
	DB    0,0
	DB    0,0

POT_P5: DB    LOW SFT_P5,HIGH SFT_P5
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    04AH
	DB    LOW R_CHAR,HIGH R_CHAR
	DB    4,0
	DB    0,0
	DB    0,0

POT_P6: DB    LOW SFT_P6,HIGH SFT_P6
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    049H
	DB    LOW R_CHAR,HIGH R_CHAR
	DB    4,0
	DB    0,0
	DB    0,0

POT_P7: DB    LOW SFT_P1,HIGH SFT_P1
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    045H
	DB    LOW R_INTEG,HIGH R_INTEG
	DB    6,0
	DB    LOW RT_WLEN,HIGH RT_WLEN
	DB    0,0

POT_P8: DB    LOW SFT_P1,HIGH SFT_P1
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    049H
	DB    LOW R_INTEG,HIGH R_INTEG
	DB    8,0
	DB    LOW RT_WLEN,HIGH RT_WLEN
	DB    0,0

POT_P9: DB    LOW SFT_P1,HIGH SFT_P1
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    04DH
	DB    LOW R_INTEG,HIGH R_INTEG
	DB    4,0
	DB    LOW RT_WLEN,HIGH RT_WLEN
	DB    0,0

POT_R1: DB    LOW SFT_R1,HIGH SFT_R1
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    020H
	DB    LOW RU_CH_R,HIGH RU_CH_R
	DB    0,0
	DB    0,0
	DB    0,0

POT_R2: DB    LOW SFT_R1,HIGH SFT_R1
	DB    LOW M_M_NH,HIGH M_M_NH
	DB    040H
	DB    LOW RU_IT_R,HIGH RU_IT_R
	DB    LOW CYCLE,HIGH CYCLE
	DB    LOW RT_CYCL,HIGH RT_CYCL
	DB    LOW CYC_NEW,HIGH CYC_NEW

; Cteni jednotlivych cisel

RT_WLEN:DB    034H
	DB    LOW 0,HIGH 0
	DB    LOW 700,HIGH 700
	DB    LOW 2,HIGH 2
	DB    LCD_HOME,'Out of range    ',0
	DB    LCD_HOME,'Value 0 to 700  ',0,0

RT_TIME:DB    042H
	DB    LOW 0,HIGH 0
	DB    LOW 0FFFEH,HIGH 0FFFEH
	DB    0,0
	DB    LCD_HOME,'Out of range    ',0
	DB    LCD_HOME,'Value 0. to 600.',0,0

RT_CYCL:DB    030H
	DB    LOW 0,HIGH 0
	DB    LOW 999,HIGH 999
	DB    0,0
	DB    LCD_HOME,'Out of range    ',0
	DB    LCD_HOME,'Value 0 to 999  ',0,0

RT_uL_A:DB    020H
	DB    LOW 1,HIGH 1
	DB    LOW 99,HIGH 99
	DB    0,0
	DB    LCD_HOME,'Out of range    ',0
	DB    LCD_HOME,'Range 1 to 99',0,0

; Tabulky funkci

SFT_15: DB    K_UP
	DB    3,0
	DB    LOW UP_BDP,HIGH UP_BDP

	DB    K_DOWN
	DB    -1,2
	DB    LOW DO_BDP,HIGH DO_BDP

	DB    K_LEFT
	DB    LOW POT_9,HIGH POT_9
	DB    LOW SET_POT,HIGH SET_POT

	DB    K_RIGHT
	DB    LOW POT_16,HIGH POT_16
	DB    LOW SET_POT,HIGH SET_POT

SFT_14: DB    K_LEFT
	DB    LOW POT_15,HIGH POT_15
	DB    LOW SET_POT,HIGH SET_POT

	DB    K_ENTER
	DB    0,0
	DB    LOW LAN_INI,HIGH LAN_INI

	DB    0FFH
	DB    LOW SFT_0,HIGH SFT_0

SFT_13: DB    K_DOWN
	DB    251,250
	DB    LOW UP_BDP,HIGH UP_BDP

	DB    K_UP
	DB    0,1
	DB    LOW DO_BDP,HIGH DO_BDP

SFT_12:	DB    K_INS
	DB    0,0
	DB    LOW INS_PRG,HIGH INS_PRG

	DB    K_DEL
	DB    0,0
	DB    LOW DEL_PRG,HIGH DEL_PRG

	DB    K_ENTER
	DB    1,0
	DB    LOW SEL_PRG,HIGH SEL_PRG

	DB    K_LEFT
	DB    LOW POT_13,HIGH POT_13
	DB    LOW SET_POT,HIGH SET_POT

	DB    K_RIGHT
	DB    LOW POT_14,HIGH POT_14
	DB    LOW SET_POT,HIGH SET_POT

	DB    0FFH
	DB    LOW SFT_0,HIGH SFT_0

SFT_11: DB    K_ENTER
	DB    0,0
	DB    LOW M_MORUN,HIGH M_MORUN

SFT_10: DB    K_LEFT
	DB    LOW POT_11,HIGH POT_11
	DB    LOW SET_POT,HIGH SET_POT

	DB    K_RIGHT
	DB    LOW POT_12,HIGH POT_12
	DB    LOW SET_POT,HIGH SET_POT

	DB    0FFH
	DB    LOW SFT_0,HIGH SFT_0

SFT_9:  DB    K_UP
	DB    0,-48
	DB    LOW UP_BDP,HIGH UP_BDP

	DB    K_DOWN
	DB    -49,-1
	DB    LOW DO_BDP,HIGH DO_BDP

	DB    K_LEFT
	DB    LOW POT_8,HIGH POT_8
	DB    LOW SET_POT,HIGH SET_POT

	DB    K_RIGHT
	DB    LOW POT_15,HIGH POT_15
	DB    LOW SET_POT,HIGH SET_POT

SFT_8:  DB    K_RIGHT
	DB    LOW POT_9,HIGH POT_9
	DB    LOW SET_POT,HIGH SET_POT

	DB    K_ENTER
	DB    0,0
	DB    LOW LAN_INI,HIGH LAN_INI

	DB    0FFH
	DB    LOW SFT_0,HIGH SFT_0

SFT_4:  DB    K_1
	DB    0,1
	DB    LOW R_AUXU,HIGH R_AUXU

	DB    K_2
	DB    0,2
	DB    LOW R_AUXU,HIGH R_AUXU

	DB    K_3
	DB    0,4
	DB    LOW R_AUXU,HIGH R_AUXU

	DB    K_4
	DB    0,8
	DB    LOW R_AUXU,HIGH R_AUXU

	DB    0FFH
	DB    LOW SFT_0,HIGH SFT_0

SFT_3:  DB    K_LEFT
	DB    LOW POT_2,HIGH POT_2
	DB    LOW SET_POT,HIGH SET_POT

	DB    K_UP
	DB    6,0
	DB    LOW UP_BDP,HIGH UP_BDP

	DB    K_DOWN
	DB    -1,5
	DB    LOW DO_BDP,HIGH DO_BDP

SFT_2:  DB    K_LEFT
	DB    LOW POT_1,HIGH POT_1
	DB    LOW SET_POT,HIGH SET_POT

	DB    K_RIGHT
	DB    LOW POT_3,HIGH POT_3
	DB    LOW SET_POT,HIGH SET_POT

	DB    K_UP
	DB    10,0
	DB    LOW UP_BDP,HIGH UP_BDP

	DB    K_DOWN
	DB    -1,9
	DB    LOW DO_BDP,HIGH DO_BDP

SFT_1:  DB    K_RIGHT
	DB    LOW POT_2,HIGH POT_2
	DB    LOW SET_POT,HIGH SET_POT

	DB    K_ATTEN
	DB    LOW POT_2,HIGH POT_2
	DB    LOW SET_POT,HIGH SET_POT

SFT_0:  DB    K_MODE
	DB    0,0
	DB    LOW M_MODE,HIGH M_MODE

	DB    K_PROG
	DB    0,0
	DB    LOW PROG_INV,HIGH PROG_INV

	DB    K_END
	DB    0,0
	DB    LOW M_KEND,HIGH M_KEND

	DB    K_MARK
	DB    0,0
	DB    LOW M_MARK,HIGH M_MARK

	DB    K_RUN
	DB    0,0
	DB    LOW RUN_PRG,HIGH RUN_PRG

	DB    K_LIST
	DB    LOW DIT_7,HIGH DIT_7
	DB    LOW SET_DIT,HIGH SET_DIT

	DB    K_CYCLE
	DB    LOW DIT_5,HIGH DIT_5
	DB    LOW SET_DIT,HIGH SET_DIT

	DB    K_AUX
	DB    LOW DIT_2,HIGH DIT_2
	DB    LOW SET_DIT,HIGH SET_DIT

	DB    K_ABS
	DB    LOW DIT_1,HIGH DIT_1
	DB    LOW SET_DIT,HIGH SET_DIT

	DB    K_PRET
	DB    LOW DIT_8,HIGH DIT_8
	DB    LOW SET_DIT,HIGH SET_DIT

SFT_SP0:DB    K_ZERO
	DB    0,0
	DB    LOW S_ZERO,HIGH S_ZERO

	DB    K_UVL
	DB    010H,011H
	DB    LOW S_LAMP,HIGH S_LAMP

	DB    K_UVH
	DB    020H,010H
	DB    LOW S_LAMP,HIGH S_LAMP

	DB    K_VIS
	DB    004H,003H
	DB    LOW S_LAMP,HIGH S_LAMP

	DB    K_LOFF
	DB    000H,007H
	DB    LOW S_LAMP,HIGH S_LAMP

	DB    0

SFT_P6:	DB    K_UP
	DB    6,0
	DB    LOW UP_BDP,HIGH UP_BDP

	DB    K_DOWN
	DB    -1,5
	DB    LOW DO_BDP,HIGH DO_BDP

SFT_P5:	DB    K_UP
	DB    10,0
	DB    LOW UP_BDP,HIGH UP_BDP

	DB    K_DOWN
	DB    -1,9
	DB    LOW DO_BDP,HIGH DO_BDP

SFT_P4: DB    K_UP
	DB    3,0
	DB    LOW UP_BDP,HIGH UP_BDP

	DB    K_DOWN
	DB    -1,2
	DB    LOW DO_BDP,HIGH DO_BDP

	DB    0FFH
	DB    LOW SFT_P1,HIGH SFT_P1

SFT_P2: DB    K_1
	DB    0,001H
	DB    LOW R_AUXU,HIGH R_AUXU

	DB    K_2
	DB    0,002H
	DB    LOW R_AUXU,HIGH R_AUXU

	DB    K_3
	DB    0,004H
	DB    LOW R_AUXU,HIGH R_AUXU

	DB    K_4
	DB    0,008H
	DB    LOW R_AUXU,HIGH R_AUXU

SFT_P1: DB    K_DOWN
	DB    0,0
	DB    LOW SET_NEX,HIGH SET_NEX

	DB    K_UP
	DB    0,0
	DB    LOW SET_PRE,HIGH SET_PRE

	DB    K_LEFT
	DB    -1,0
	DB    LOW MOD_LNP,HIGH MOD_LNP

	DB    K_RIGHT
	DB    1,0
	DB    LOW MOD_LNP,HIGH MOD_LNP

	DB    K_ENTER
	DB    1,0
	DB    LOW ENT_PRG,HIGH ENT_PRG

	DB    K_DEL
	DB    0,0
	DB    LOW DEL_LN,HIGH DEL_LN

	DB    K_INS
	DB    LOW MENU_P1,HIGH MENU_P1
	DB    LOW SET_MENU,HIGH SET_MENU

SFT_P0:	DB    K_END
	DB    0,1
	DB    LOW INS_LN,HIGH INS_LN

	DB    K_AUX
	DB    0,2
	DB    LOW INS_LN,HIGH INS_LN

	DB    K_ABS
	DB    0,3
	DB    LOW INS_LN,HIGH INS_LN

	DB    K_ZERO
	DB    0,4
	DB    LOW INS_LN,HIGH INS_LN

	DB    K_ATTEN
	DB    0,5
	DB    LOW INS_LN,HIGH INS_LN

	DB    K_MARK
	DB    0,7
	DB    LOW INS_LN,HIGH INS_LN

	DB    K_PROG
	DB    1,0
	DB    LOW PROG_OU,HIGH PROG_OU

	DB    0

SFT_R1: DB    K_CTRL
	DB    0,0
	DB    LOW M_PSPD,HIGH M_PSPD

	DB    K_ABS
	DB    LOW DIT_R1,HIGH DIT_R1
	DB    LOW SET_DIT,HIGH SET_DIT

	DB    K_CYCLE
	DB    LOW DIT_R2,HIGH DIT_R2
	DB    LOW SET_DIT,HIGH SET_DIT

	DB    K_AUX
	DB    LOW DIT_R3,HIGH DIT_R3
	DB    LOW SET_DIT,HIGH SET_DIT

	DB    K_END
	DB    0,0
	DB    LOW RU_BRK,HIGH RU_BRK

	DB    0

T_MABS: DB    LCD_CLR,0BDH,'nm AUFS AU ',0B2H,0

T_MANA: DB    LCD_CLR,'AUX    -S-  -R- '
	DB    C_LIN2, 'OUTPUT',0

T_MSCOM:DB    LCD_CLR,'Adr kBd Mode Grp',0

T_ALRM: DB    LCD_CLR,'TIME ALARM'
	DB    C_LIN2, '           NULL',0

T_PRSL: DB    LCD_CLR,'NUM PROGRAM',0

T_PRNUL:DB    LCD_CLR,' End of program',0

T_PR_1: DB    LCD_CLR,'TIME'
	DB    C_LIN2, '      ** End **',0

T_PR_2: DB    LCD_CLR,'TIME   -S-  AUX'
	DB    C_LIN2, '            OUTP',0

T_PR_3: DB    LCD_CLR,'TIME  WAVELENGTH'
	DB    C_LIN2, '           ',0BDH,'nm',0

T_PR_4: DB    LCD_CLR,'TIME  ZERRO',0

T_PR_5: DB    LCD_CLR,'TIME  ATTENUATOR',0

T_PR_6: DB    LCD_CLR,'TIME  ',0B2H,' CONST.',0

T_PR_7: DB    LCD_CLR,'TIME'
	DB    C_LIN2, '       MARK',0

T_PR_8: DB    LCD_CLR,'TIME  LO  HI STP',0

T_RUNB: DB    LCD_CLR,'TIME ',0BDH,'nm AU ',0

T_RUNR: DB    LCD_CLR,'CYCLE ACTU FINAL',0

T_RUNA: DB    LCD_CLR,'TIME   -S-  -R-',0

T_PRET: DB    LCD_CLR,' CHANEL   VALUE',0

T_PR_CO:DB    LCD_CLR,'  Compiling'
	DB    C_LIN2, '   program',0

T_ER_CO:DB    LCD_CLR,'  No space for'
	DB    C_LIN2, 'wavelength table',0
	DB    LCD_CLR,'Short program !',0,0

T_ER_SC:DB    LCD_CLR,'No scannig def. '
	DB    C_LIN2, '  in program    ',0
	DB    LCD_CLR,'Use PROG, INS L.'
	DB    C_LIN2, 'chose Scanning  ',0,0

T_ER_SZ:DB    LCD_CLR,' Use multiwave  '
	DB    C_LIN2, '  zerro first   ',0,0

T_RU_BR:DB    LCD_CLR,'Break program ?',0

ALRM_BT:DB    LCD_HOME,'** User timer **',0,0

ABS_OET:DB    LCD_HOME,'ABS output error',0
	DB    LCD_HOME,'Check computer'
	DB    C_LIN2,  'and uLAN cable !',0,0

T_PREND:DB    LCD_HOME,'End of program. ',0,0

ERR_SRD:DB    LCD_HOME,'SRAM data may be'
	DB    C_LIN2,  'wrong. Press key',0,0

T_ST_01:DB    LCD_CLR,'Compile data now',0

ERR_SNC:DB    LCD_CLR,'Sync power ERROR'
	DB    C_LIN2, 'Press key',0,0

SFVER_T:DB    LCD_CLR,'%VERSION'
	DB    C_LIN2 ,' (c) 1991',0

ERR_EPR:DB    LCD_CLR,'EPROM error !',0

$NOLIST
; *******************************************************************
; Texty jednotlivych menu

MENU_P1:DB    LOW MENT_P1,HIGH MENT_P1
	DB    LOW M_MOMH1,HIGH M_MOMH1
	DB    LOW SFT_P0,HIGH SFT_P0
	DB    0,0
	DB    LOW SET_LN,HIGH SET_LN
	DB    0,1
	DB    LOW INS_LN,HIGH INS_LN
	DB    0,2
	DB    LOW INS_LN,HIGH INS_LN
	DB    0,3
	DB    LOW INS_LN,HIGH INS_LN
	DB    0,4
	DB    LOW INS_LN,HIGH INS_LN
	DB    0,5
	DB    LOW INS_LN,HIGH INS_LN
	DB    0,6
	DB    LOW INS_LN,HIGH INS_LN
	DB    0,7
	DB    LOW INS_LN,HIGH INS_LN
	DB    0,8
	DB    LOW INS_LN,HIGH INS_LN
	DB    1,0
	DB    LOW PROG_OU,HIGH PROG_OU

	DB    0FEH,0FEH,0FEH
MENT_P1:DB    0,0FFH,1
	DB    0FFH,0FFH,0FFH
	DB    'Exit',0
	DB    1,0FFH,1,0FFH,0FFH,0FFH
	DB    'End of cycle',0
	DB    2,0FFh,1,0FFH,0FFH,0FFH
	DB    'Auxual outputs',0
	DB    3,0FFh,1,0FFH,0FFH,0FFH
	DB    'Wavelength',0
	DB    4,0FFh,1,0FFH,0FFH,0FFH
	DB    'Zerro',0
	DB    5,0FFh,1,0FFH,0FFH,0FFH
	DB    'Attenuator',0
	DB    6,0FFh,1,0FFH,0FFH,0FFH
	DB    'Time const',0
	DB    7,0FFh,1,0FFH,0FFH,0FFH
	DB    'Mark',0
	DB    8,0FFh,1,0FFH,0FFH,0FFH
	DB    'Scaning',0
	DB    9,0FFh,1,0FFH,0FFH,0FFH
	DB    'Exit program mode',0
	DB    0FEH,0FEH,0FEH

; *******************************************************************
; Napovedne texty

MSWL_HL:DB    LOW WAVE_HL,HIGH WAVE_HL,1,0FFH,0FFH,0FFH
	DB    'Wavelength',0
	DB    LOW H310_HL,HIGH H310_HL,1,0FFH,0FFH,0FFH
	DB    'Manual mode',0
	DB    0FEH,0FEH,0FEH

MAUF_HL:DB    LOW AUFS_HL,HIGH AUFS_HL,1,0FFH,0FFH,0FFH
	DB    'AU full scale',0
	DB    LOW H310_HL,HIGH H310_HL,1,0FFH,0FFH,0FFH
	DB    'Manual mode',0
	DB    0FEH,0FEH,0FEH

P2040_H:DB    LOW MAUX_HL,HIGH MAUX_HL,1,0FFH,0FFH,0FFH
	DB    'Aux output/input',0
	DB    LOW H310_HL,HIGH H310_HL,1,0FFH,0FFH,0FFH
	DB    'Manual mode',0
	DB    0FEH,0FEH,0FEH

AUFS_HL:DB    0FFH,0FFH,0FFH
	DB    'By cursor keys',0
	DB    0FFH,0FFH,0FFH
	DB    'UP and DOWN',0
	DB    0FFH,0FFH,0FFH
	DB    'you can set',0
	DB    0FFH,0FFH,0FFH
	DB    'output range',0
	DB    0FFH,0FFH,0FFH
	DB    'for recorder.',0
	DB    0FEH,0FEH,0FEH

MTAU_HL:DB    LOW TAU_HL,HIGH TAU_HL,1,0FFH,0FFH,0FFH
	DB    'Time constant',0
	DB    LOW H310_HL,HIGH H310_HL,1,0FFH,0FFH,0FFH
	DB    'Manual mode',0
	DB    0FEH,0FEH,0FEH

TAU_HL: DB    0FFH,0FFH,0FFH
	DB    'By cursor keys',0
	DB    0FFH,0FFH,0FFH
	DB    'UP and DOWN',0
	DB    0FFH,0FFH,0FFH
	DB    'you can set time',0
	DB    0FFH,0FFH,0FFH
	DB    'constant',0
	DB    0FEH,0FEH,0FEH

WAVE_HL:DB    0FFH,0FFH,0FFH
	DB    'You can set ',0
	DB    0FFH,0FFH,0FFH
	DB    'wavelength ',0
	DB    0FFH,0FFH,0FFH
	DB    'from 0 to 700 nm',0
	DB    0FEH,0FEH,0FEH

MAUX_HL:DB    0FFH,0FFH,0FFH
	DB    ' AUX_OUTPUT :',0
	DB    0FFH,0FFH,0FFH
	DB    'By keys 1 2 3 4',0
	DB    0FFH,0FFH,0FFH
	DB    'control outputs',0
	DB    0FFH,0FFH,0FFH
	DB    'and read inputs.',0
	DB    0FEH,0FEH,0FEH

HELP_HL:DB    LOW HELP_H1,HIGH HELP_H1,1,0FFH,0FFH,0FFH
	DB    'Use cursor+ENTER',0
	DB    LOW H200_HL,HIGH H200_HL,1,0FFH,0FFH,0FFH
	DB    'INDEX',0
HELP_H1:DB    LOW HELP_H2,HIGH HELP_H2,1,0FFH,0FFH,0FFH
	DB    'Choose topic',0
	DB    LOW HELP_H2,HIGH HELP_H2,1,0FFH,0FFH,0FFH
	DB    'and press ENTER',0
HELP_H2:DB    0FFH,0FFH,0FFH
	DB    'When you want',0
	DB    0FFH,0FFH,0FFH
	DB    'leave help press',0
	DB    0FFH,0FFH,0FFH
	DB    'any other key',0
	DB    0FFH,0FFH,0FFH
	DB    'This help you',0
	DB    0FFH,0FFH,0FFH
	DB    'every pop-up by',0
	DB    0FFH,0FFH,0FFH
	DB    'twicestroke HELP',0
	DB    0FFH,0FFH,0FFH
	DB    'New help apears',0
	DB    0FFH,0FFH,0FFH
	DB    'after every',0
	DB    0FFH,0FFH,0FFH
	DB    'change of cursor',0
	DB    0FFH,0FFH,0FFH
	DB    'position.',0
	DB    0FEH,0FEH,0FEH
H200_HL:DB    0FFH,0FFH,0FFH
	DB    ' Index :',0
	DB    LOW H300_HL,HIGH H300_HL,1
	DB    LOW ABOU_HL,HIGH ABOU_HL,11,0FFH,0FFH,0FFH
	DB    'MODE KEYS ABOUT',0
	DB    0FEH,0FEH,0FEH
H300_HL:DB    0FFH,0FFH,0FFH
	DB    ' Mode :',0
	DB    LOW H310_HL,HIGH H310_HL,1
	DB    0FFH,0FFH,0FFH
	DB    'MANUAL PROG',0
	DB    0FEH,0FEH,0FEH

H310_HL:DB    0FFH,0FFH,0FFH
	DB    'When press ABS',0
	DB    0FFH,0FFH,0FFH
	DB    'in manual mode',0
	DB    LOW ABS_HL,HIGH ABS_HL,13,0FFH,0FFH,0FFH
	DB    'you can see ABS',0
	DB    LOW WAVE_HL,HIGH WAVE_HL,5,0FFH,0FFH,0FFH
	DB    'set WAVELENGTH',0
	DB    LOW AUFS_HL,HIGH AUFS_HL,1,0FFH,0FFH,0FFH
	DB    'AUFS ',0
	DB    LOW TAU_HL,HIGH TAU_HL,1,0FFH,0FFH,0FFH
	DB    'TIME CONSTANT',0
	DB    0FEH,0FEH,0FEH

ABS_HL: DB    0FFH,0FFH,0FFH
	DB    'You can read',0
	DB    0FFH,0FFH,0FFH
	DB    'actual',0
	DB    0FFH,0FFH,0FFH
	DB    'absorbance',0
	DB    0FEH,0FEH,0FEH

ABOU_HL:DB    LOW ABOU_H1,HIGH ABOU_H1,1,0FFH,0FFH,0FFH
	DB    'LCP 4000 v1.0',0
	DB    0FFH,0FFH,0FFH
	DB    ' PiKRON s.r.o.',0
ABOU_H1:DB    0FFH,0FFH,0FFH
	DB    'general design',0
	DB    0FFH,0FFH,0FFH
	DB    '    L.Pisa',0
	DB    0FFH,0FFH,0FFH
	DB    'hardware',0
	DB    0FFH,0FFH,0FFH
	DB    'Porazil Knourek',0
	DB    0FFH,0FFH,0FFH
	DB    'software',0
	DB    0FFH,0FFH,0FFH
	DB    0F7H,'soft P.Pisa',0
	DB    0FFH,0FFH,0FFH
	DB    'Praha   (c) 1994',0
	DB    0FFH,0FFH,0FFH
	DB    '14.07. 10:15 am',0
	DB    0FEH,0FEH,0FEH

M_M_NH: DB    0FFH,0FFH,0FFH
	DB    'No help',0
	DB    0FFH,0FFH,0FFH
	DB    'avayable',0
	DB    0FEH,0FEH,0FEH

END